/* Created by Anjuta version 1.2.3 */
/*	This file will not be overwritten */


#include <CpColladaParser.h>




void CCpColladaParser::startElement(const std::string& namespaceURI, const std::string& localName,
                               const std::string& qName, const SAX::Attributes& atts)
{
  xmlbaseTracker_.startElement(atts);

  std::string id = atts.getValue("id");
  std::string count = atts.getValue("count");
  if(id.empty() && count.empty() && qName.compare("p") ) //means not equal "p"
    return;
  
  istringstream is(count);
  
  if ( id.find("Geometry-Position" ) != string::npos  ) 
  {
	  SetState( CPCP_VERTICES ); 
	
  }
  if ( id.find("Normals-array" ) != string::npos ) 
  {
	  SetState( CPCP_NORMALS ); 
	  
  }
  if ( id.find("UV-array" ) != string::npos ) 
  {
	  SetState( CPCP_UV ); 
	 
  }
  if ( id.empty() && ( qName.compare("triangles") == 0 ) && !count.empty() ) 
  {
	  SetState( CPCP_INDICES );
	  is >> iTempIndicesCount;
	  iTempIndicesCount*=9;	  
	  pTempIndices = new uint [iTempIndicesCount];
  }
  
  
  if ( (iState == CPCP_VERTICES ) && ( !count.empty() ) )
  {
	  SetState( CPCP_VERTICES_LOAD );
	  is >> iTempVertexCount;
	  iTempVertexCount/=3;
	  pTempVertexArray = new Vector3f[ iTempVertexCount ];
	 
  }
  
  if ( (iState == CPCP_NORMALS ) && ( !count.empty() ) )
  {
	  SetState( CPCP_NORMALS_LOAD );
	  is >> iTempNormalsCount;
	  iTempNormalsCount/=3;
	  pTempNormalArray = new Vector3f[ iTempNormalsCount ];

  }
  
  if ( (iState == CPCP_UV ) && ( !count.empty() ) )
  {
	  SetState( CPCP_UV_LOAD );
	  is >> iTempUVCount;
	  iTempUVCount/=2;
	  pTempUVArray = new Vector2f[ iTempUVCount ];
	 
  }
  
  if ( /* (iState == CPCP_INDICES ) && */( qName.compare("p") == 0 ) )
  {
	  SetState( CPCP_INDICES_LOAD );
  }
  
  
} // startElement 

void CCpColladaParser::endElement(const std::string&, const std::string& localName,
                             const std::string&)
{
	if ( iState == CPCP_VERTICES_LOAD )
	{
		for (int i =0; i<iTempVertexCount; i++)
		{	
		 	sContainerV >> pTempVertexArray[i].x;
			sContainerV >> pTempVertexArray[i].y;
			sContainerV >> pTempVertexArray[i].z;
		}
		
		
	}
	
	if ( iState == CPCP_NORMALS_LOAD )
	{
		for (int i =0; i<iTempNormalsCount; i++)
		{	
		 	sContainerN >> pTempNormalArray[i].x;
			sContainerN >> pTempNormalArray[i].y;
			sContainerN >> pTempNormalArray[i].z;
		}
	
	}
	
	if ( iState == CPCP_UV_LOAD )
	{
		for (int i =0; i<iTempUVCount; i++)
		{	
		 	sContainerT >> pTempUVArray[i].u;
			sContainerT >> pTempUVArray[i].v;
		}
		
			
	}
	
	if ( iState == CPCP_INDICES_LOAD )
	{
		uint iTemp; 
		pVertexArray = new Vector3f[iTempIndicesCount/3];
		pNormalArray = new Vector3f[iTempIndicesCount/3];
		pUVArray     = new Vector2f[iTempIndicesCount/3];
		pIndexArray  = new uint[iTempIndicesCount/3];
		
		for (int i =0; i<iTempIndicesCount; i+=3)
		{	
		 	sContainerI >> iTemp;
			pVertexArray[i/3] = pTempVertexArray[iTemp];
			
			sContainerI >> iTemp;
			pNormalArray[i/3] = pTempNormalArray[iTemp];
			
			sContainerI >> iTemp;
			pUVArray[i/3] = pTempUVArray[iTemp];
			
			pIndexArray[i/3]=i/3+iStartingIndex;
		}
		
					
	}
	
	SetState( CPCP_NO_STATE );
  	xmlbaseTracker_.endElement();
} // endElement

// end of file

void CCpColladaParser::characters(const std::string& ch)
{
	if ( iState == CPCP_VERTICES_LOAD )
		sContainerV << ch;
	
	if ( iState == CPCP_NORMALS_LOAD )
		sContainerN << ch;
	
	if ( iState == CPCP_UV_LOAD )
		sContainerT << ch;
	
	if ( iState == CPCP_INDICES_LOAD )
		sContainerI << ch;
}
