#ifndef _CCpColladaParser
#define _CCpColladaParser

#include <iostream>

using namespace std;

#ifdef _MSC_VER
#pragma warning(disable : 4786)
#endif

#include <Interfaces.h>
#include <SAX/helpers/DefaultHandler.h>
#include <SAX/InputSource.h>
#include <SAX/XMLReader.h>
#include <SAX/helpers/XMLBaseSupport.h>
#include <sstream>

const int CPCP_NO_STATE       = 0;
const int CPCP_VERTICES       = 1;
const int CPCP_NORMALS        = 2; 
const int CPCP_UV     		  = 3; 
const int CPCP_INDICES        = 4;
const int CPCP_VERTICES_LOAD  = 5;
const int CPCP_NORMALS_LOAD   = 6;
const int CPCP_UV_LOAD		  = 7;
const int CPCP_INDICES_LOAD   = 8;

class CCpColladaParser : public SAX::DefaultHandler
{
  public:
	vector<SGraphicObject> MeshArray;
    Vector3f* pVertexArray;
	Vector3f* pNormalArray;
  	Vector2f* pUVArray;
  	uint*   pIndexArray;
    uint    iStartingIndex;
  	uint	  iTempIndicesCount;
  	virtual void SetState(int State) {iState=State;}
    virtual void startElement(const std::string& namespaceURI, const std::string& localName,
                              const std::string& qName, const SAX::Attributes& atts);
    virtual void endElement(const std::string& namespaceURI, const std::string& localName,
                            const std::string& qName);
    virtual void characters(const std::string& ch);

    virtual void warning(const SAX::SAXParseException& e) { fatalError(e); }
    virtual void error(const SAX::SAXParseException& e) { fatalError(e); }

  private:
	Vector3f* pTempVertexArray;
	Vector3f* pTempNormalArray;
  	Vector2f* pTempUVArray;
  	uint*   pTempIndices;
  	uint    iTempVertexCount;
  	uint	  iTempNormalsCount;
  	uint	  iTempUVCount;  	
  	stringstream sContainerV;
  	stringstream sContainerN;
  	stringstream sContainerT;
  	stringstream sContainerI;
  	int iState;
    SAX::XMLBaseSupport xmlbaseTracker_;
}; // class SimpleHandler

#endif
