/***************************************************************************
 *            CpGl.h
 *
 *  Tue Dec 26 00:49:01 2006
 *  Copyright  2006  Stefan Tolic
 ****************************************************************************/
#ifndef _CpGl
#define _CpGl
#include <GL/glew.h>
#include <GL/gl.h>
#include <math.h>
#include <iostream>
#include <vector>
#include <Interfaces.h>



using namespace std;

/* to be removed till.....*/
    static GLfloat v0[] = { -1.0f, -1.0f,  1.0f };
    static GLfloat v1[] = {  1.0f, -1.0f,  1.0f };
    static GLfloat v2[] = {  1.0f,  1.0f,  1.0f };
    static GLfloat v3[] = { -1.0f,  1.0f,  1.0f };
    static GLfloat v4[] = { -1.0f, -1.0f, -1.0f };
    static GLfloat v5[] = {  1.0f, -1.0f, -1.0f };
    static GLfloat v6[] = {  1.0f,  1.0f, -1.0f };
    static GLfloat v7[] = { -1.0f, -1.0f,  1.0f,
							 1.0f, -1.0f,  1.0f, 
							 1.0f,  1.0f,  1.0f};
    static GLubyte red[]    = { 255,   0,   0, 255 };
    static GLubyte green[]  = {   0, 255,   0, 255 };
    static GLubyte blue[]   = {   0,   0, 255, 255 };
    static GLubyte white[]  = { 255, 255, 255, 255 };
    static GLubyte yellow[] = {   0, 255, 255, 255 };
    static GLubyte black[]  = {   0,   0,   0, 255 };
    static GLubyte orange[] = { 255, 255,   0, 255 };
    static GLubyte purple[] = { 255,   0, 255,   0 };
/*   .....here     */



class CCpGl : IGraphicInterface
{
	protected:
		public:
		GLuint vbos[4];
		unsigned int *ibos;
		unsigned int iStaticIndexBuffer;
		vector<SGraphicObject> pGraphicObjectArray;
		int iGraphicObjectCount;
		Vector3f* pVertexArray;
		Vector3f* pNormalArray;
		long lVertexCount;
		Vector2f* pTexCordArray;
		long lTexCordCount;	
		SLightObject* pLightObjectArray;
		int iLightCount;
  		GLhandleARB* Shaders;
		GLuint* pTextureArray;
		GLuint iTextureCount;
		GLuint  iScreen, iColor, iDepth, iMinimap, iGlowScreen, iGlowColor, iGlowDepth, iGlowScreen2, iGlowColor2, iGlowDepth2, iGlowScreen3, iGlowColor3, iGlowDepth3, iStencilScreen, iStencilColor;
		GLboolean bUseShaders;
		IGameInterface* GameInterface;
		Vector3f* pAttributeArray;
		
		vector<Vector3f> Mesh;
		vector<Vector3f> Normals;
		vector<Vector2f> UV;
		
	
        Vector3f sPos;		
		float ax,ay;

		virtual void Clear();	
		virtual void PrepairObjectForDrawing(int i);
		
		virtual int LoadShader(char* fs, char* vs, GLuint i);
		virtual void PrepairShader(GLuint ObjectNo);
		virtual void PrepairShader(char* c, int i);
		virtual int LoadObject(char* c,GLuint iBeginIndex, int genNormals);
		virtual void DrawMinimap();
		virtual void SetRenderToTexture(GLuint fb, GLuint color, GLuint depth, GLuint stencil);
		virtual void SetRenderToScreen();
	public:
		GLint lmap;
		float dx,dy,dz;
		int cntr;

		CCpGl();
		virtual int LoadObjectsOld(char* c);
		virtual int LoadObjects(char* c);
	        virtual int LoadShaders(char* c);
		virtual int LoadTextures(char* c);
	        virtual GLuint LoadTexture (char* Textname, int mml );	
		virtual void RenderLights();
		virtual void Draw();	
		virtual void DrawDeath();	
		virtual void DrawBlend();
		virtual void TestDraw();
		virtual void DrawBoxEnv();
                virtual void SaveMatrixState();
                virtual void LoadMatrixState();
		virtual void IdentityAll();
		virtual void DrawImage(float x1, float y1, float x2, float y2, float u1, float v1, float u2, float v2, int img, int flag);
		virtual void Splash();
		virtual void SetPos( Vector3f pos ) 
	        	{
				sPos=pos;
			}
		virtual void AddToPos ( Vector3f v )
			{
				sPos.x=sPos.x+v.x;
				sPos.y=sPos.y+v.y;
				sPos.z=sPos.z+v.z;
			}
		virtual void SetAngles (float a, float b);
		virtual void AddToAngles (float a,float b);
		virtual Vector3f GetDirection ()
			{
				return Vector3f(dx,dy,dz);
			}
		virtual void SetGameInterface(IGameInterface* Interface) {GameInterface=Interface;}
	    virtual SGraphicObject* GetObject(int i){return &pGraphicObjectArray[i];}
		virtual Vector3f* GetVertices() {return pVertexArray;}
	 	virtual int GetEdges(int i);
	 	virtual void DrawMenu(int state);
	
};



int  get_edges(void* cpgl);

#endif
