/***************************************************************************
 *            CpSDL.h
 *
 *  Wed Dec 27 18:33:31 2006
 *  Copyright  2006  Stefan Tolic
 ****************************************************************************/
#ifndef _CpSDL
#define _CpSDL
#define MAX_EVENTS 10

#include <Interfaces.h>
#include <CpGl.h>
#include <SDL/SDL.h>
#include <iostream>


using namespace std;

struct set
{
	SDL_Event* events[MAX_EVENTS];
	set();
	
	int add(SDL_Event* e);
	void remove(SDL_Event e);
	
};


class IGameInterface;
	
class CCpSDL
{ 
	protected:	
		set events;
		IGameInterface* GameInterface;
		IGraphicInterface* GraphicInterface;
		Uint32 Time;
		Uint32 TimeSync;
	
	public:			
		CCpSDL(char name[],char icon[]);
		virtual void SetGameInterface(IGameInterface* i) { GameInterface = i; } 
		virtual void SetGraficInterface(IGraphicInterface* i) { GraphicInterface = i; }
		virtual void CheckInput();
		virtual void CheckMenuInput();
		virtual void EndCyrcle();
	    unsigned long GetTime() { return SDL_GetTicks()+TimeSync;}
		virtual void SetTimeOffset(unsigned long o)
		{
			TimeSync = o;
		}
		
};

#endif
