#include <CpSockets.h>
#include <stdio.h>
#include <CpThreadMaster.h>
#include <time.h>
unsigned long ip;

using namespace std;

struct CPConnectionID
{
	unsigned long ip;
	int iGameObjectID;
	CPConnectionID(unsigned long Ip, int id)
	{
		ip =Ip;
		iGameObjectID =id;
	}
};


CCpSDLTreader* pThreadUnit;
int mutex;

void CPSocketInit()
{
pThreadUnit = new CCpSDLTreader();
mutex=pThreadUnit->InitializeMutex();
}

vector<CPConnectionID> CID;
vector<SSocketMSG> msgArray;


void PrintConnections()
{

	cout<<"connections are:"<<endl;

	for (int i=0; i<CID.size(); i++ )
		{

			unsigned long b = CID[i].ip;
			unsigned char* c = (unsigned char*)(&b);
	
			cout << CID[i].iGameObjectID <<" from "<<( (int) *c)<<"."<<( (int) *(c+1))<<"."<<( (int) *(c+2))<<"."<<( (int) *(c+3))<<endl;

		}

}

void AddMsg(SSocketMSG* msg)
{
  pThreadUnit->LockMutex(mutex);
  msgArray.push_back(*msg);
  pThreadUnit->UnlockMutex(mutex);
}

char c[100];
IGameInterface* game;
unsigned long timeoffset = 0;
int lag = 0;


void add_lag()
{
  if (lag<=8)
  lag++;
  cout<<"Lag set to "<<lag<<endl;
}

void remove_lag()
{
  if (lag>=1)
  lag--;
  cout << "Lag set to "<<lag<<endl;
}

unsigned long myIpMask(void)
{
  int s;
  unsigned long r;
  struct ifreq ifr;
  
  if ((s=socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    return 0;

  strcpy(ifr.ifr_name, "eth0");

  if (ioctl(s, SIOCGIFNETMASK, &ifr))
    r = 0;
  else
    r = ((struct sockaddr_in *)&ifr.ifr_addr)->sin_addr.s_addr;

  close(s);
  return r;
}

unsigned long myIpAddr(void)
{
	if ( ip !=0  ) return ip;
  int s;
  unsigned long r;
  struct ifreq ifr;
  
  if ((s=socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    return 0;

  strcpy(ifr.ifr_name, "eth0");	//NAME OF YOUR INTERFACE (you can try them out until you get a vild address)
  
  if (ioctl(s, SIOCGIFADDR, &ifr))
      r = 0;
  else
      r = ((struct sockaddr_in *)&ifr.ifr_addr)->sin_addr.s_addr;

  close(s);
 
  return r;
}


char* GetIP()
{

	
	FILE* f = fopen("Ip","r");
	if (f==NULL) cout <<"NO IP!!!"<<endl;
	fscanf(f,"%s",&c);
	fclose(f);
	return c;
}

SGameMsg CPSocketCompileMSG( SSocketMSG* msg )
{
	SGameMsg Smsg;

	Smsg.type = msg->type;
	Smsg.TimeStemp = msg->gmsgT;//game->GetTime();
	Smsg.size = msg->size;
	Smsg.target = msg->target;
	for ( int i = 0; i < CID.size(); i++ )
	{
		if ( CID[i].ip == msg->targetsIP )
		Smsg.target = CID[i].iGameObjectID;	
	}
	
	if ( Smsg.type == GMSG_FRAG)
	cout << "Recepiant: " <<Smsg.target<<endl;
	
	Smsg.data = new float[Smsg.size];
	
	if (msg->size > 0)
		Smsg.data[0] = msg->f0;
	if (msg->size > 1)
		Smsg.data[1] = msg->f1;
	if (msg->size > 2)
		Smsg.data[2] = msg->f2;
	if (msg->size > 3)
		Smsg.data[3] = msg->f3;
	if (msg->size > 4)
		Smsg.data[4] = msg->f4;
	if (msg->size > 5)
		Smsg.data[5] = msg->f5;
	if (msg->size > 6)
		Smsg.data[6] = msg->f6;
	
	return Smsg;
}

int CPSocketSend(SSocketMSG* Smsg);
int Lag(void * data);
//pthread_mutex_t m;
int CPSocketListen(void* data)
{
	
       
	game = (IGameInterface*)data;
	
	unsigned int a;
	unsigned long b = myIpAddr();
	unsigned char* c = (unsigned char*)(&b);
	
	cout << "   trying listening on "<<( (int) *c)<<"."<<( (int) *(c+1))<<"."<<( (int) *(c+2))<<"."<<( (int) *(c+3))<<endl;
	
	if ( CID.empty() )
		CID.push_back( *(new CPConnectionID(myIpAddr(),1)) );

	int sck;
 	sockaddr_in sa;
 	int port=12000;
  
 	sck = socket(PF_INET, SOCK_DGRAM, 0);
  
 	sa.sin_family = AF_INET;
 	sa.sin_addr.s_addr = myIpAddr();//inet_addr("255.255.255.255");//INADDR_ANY;//
 	sa.sin_port = htons(port);
 	if (!bind( sck, (const sockaddr*)&sa, sizeof(sockaddr_in)  ));
	{
		sa.sin_addr.s_addr = inet_addr("255.255.255.255");
		bind( sck, (const sockaddr*)&sa, sizeof(sockaddr_in) );
	}
	

	
	
 	int sb=20000000;
 	if ( setsockopt(sck, SOL_SOCKET, SO_RCVBUF, (void *)&sb, sizeof(int)) == 0 ) 
		cout<< "      Socket listening" << endl; 
	
	    
	SSocketMSG* Smsg = new SSocketMSG;
	msghdr Msghdr;
	Msghdr.msg_iov = new iovec[1];
	Msghdr.msg_iovlen = 1;
	Msghdr.msg_iov[0].iov_base = (char *)Smsg;
	Msghdr.msg_iov[0].iov_len = sizeof(SSocketMSG);
	
 	 while( true ) 
	 { 
		 int bytes = 1;
		 
			 bytes = recvmsg( sck, &Msghdr,0 );
		 	//cout << "MSG"<< endl;
		 
//		 recv( sck, Smsg, sizeof(SSocketMSG), 0 );
		 

			// if (  bytes == -1 ) cout << "recvmsg ne radi"<<endl; else cout << "rec "<<bytes<<endl;
			if  ( Smsg->sendersIP!=myIpAddr() ) 
			{
		
			 if ( (Smsg->type == SMSG_CONNECT) || (Smsg->type == SMSG_CONNECT_BACK) )					
			 {	
			  cout << " tried to connect"<< endl;
				
			  SGameObject o;	
			  STankPrototype* obj = new STankPrototype(o);
				
			  obj->type = Smsg->data[0];
			  obj->iGraphicObjectId = Smsg->data[1];
			  obj->iTexture1Id = Smsg->data[2];
			  obj->iTexture2Id = Smsg->data[3];
			  obj->color[0] = Smsg->data[4];
			  obj->color[1] = Smsg->data[5];
			  obj->color[2] = Smsg->data[6];
			  obj->color[3] = Smsg->data[7];
			  obj->data[0] = Smsg->data[8];
			  obj->data[1] = Smsg->data[9];
			  obj->iActive = Smsg->data[10];

			  obj->pos.x = Smsg->f0;
			  obj->pos.y = Smsg->f1;
			  obj->pos.z = Smsg->f2;
			  obj->rot.x = Smsg->f3;
			  obj->rot.y = Smsg->f4;
			  obj->rot.z = Smsg->f5;
				
			  CID.push_back( *(new CPConnectionID(Smsg->sendersIP,game->AddGameObject(obj) ) ) );
				 
			  if (Smsg->type == SMSG_CONNECT)
			    {

				b = Smsg->sendersIP;
				c = (unsigned char*)(&b);
	
				cout << "sending SMSG_CONNECT_BACK to: "<<( (int) *c)<<"."<<( (int) *(c+1))<<"."<<( (int) *(c+2))<<"."<<( (int) *(c+3))<<endl;

			     CPSocketConnect( Smsg->sendersIP );				
			    }else

				{
					SSocketMSG SmsgSync;
	
					SmsgSync.type = SMSG_SYNC_TIME;
					SmsgSync.sendersIP = myIpAddr();
					timeoffset = SmsgSync.time = game->GetTime();
	
					if ( CID[0].ip != myIpAddr() )
						SmsgSync.recepiant = CID[0].ip;
						else
						SmsgSync.recepiant = CID[1].ip;
	//				SmsgSync.recepiant = inet_addr("255.255.255.255");
					CPSocketSend(&SmsgSync);
				}
			   
			  
			 }
		 	
			 if ( Smsg->type == SMSG_SYNC_TIME )
		    {
				SSocketMSG msg;
				msg.t2 = game->GetTime();
				msg.type = SMSG_SYNC_TIME_BACK;
				msg.recepiant = Smsg->sendersIP;
				cout << "timesync request" <<endl;
				CPSocketSend(&msg);
			}
			if ( Smsg->type == SMSG_SYNC_TIME_BACK )
		    {
				cout << "time sync engaged"<<endl;
				game->SetTimeOffset( Smsg->t2 - timeoffset /*+ game->GetTime() - Smsg->time*/ );
			}
			
			 
			if ( Smsg->type < 600 )
		    {
				//pthread_t thread;
				//game->AddMsg( CPSocketCompileMSG((SSocketMSG*)Smsg) );
				//pThreadUnit->CreateThread(Lag, (void*) Smsg );
				//pthread_create(&thread,NULL,Lag,(void*) Smsg);
				AddMsg(Smsg);
			}
		   }
		 		
     }
 
 
 close( sck );
 return 0;
}


int Lag(void * data)
{
	
	while (1)
	{
	  sleep(lag);
	  pThreadUnit->LockMutex(mutex);
		for (int i = 0; i < msgArray.size();i++)
			{
			  game->AddMsg( CPSocketCompileMSG(&msgArray[i]) );
			}
		
     	        msgArray.clear();
			
	  pThreadUnit->UnlockMutex(mutex);
	}	

return 1;
}


int port=12000;
int fragsize=1400;
int datasize=1000000;
int seq=0;
int bitrate=1000;  //kbit/s
int twait=-1;
char *udpfilename="udp";
int sock;
struct hostent *he;
struct sockaddr_in sa;
int bytes_sent;
char* buffer;
struct timeval tv1, tv2, sb;
struct timezone z;



int CPSocketOpen()
{

 	datasize = 1000000;
 	fragsize = 1000; 
 	bitrate = 10000;
 	port = 12000; 
 	twait = 1000;


 	double packetrate = 1000*bitrate/(8.0*fragsize);

 	sock = socket(PF_INET, SOCK_DGRAM, 0);
  

	if (setsockopt(sock,SOL_SOCKET,SO_BROADCAST,"10.0.11.195",sizeof("10.0.11.195"))==0 ) cout<< "huraaaa"<<endl; else cout<< ":'("<<endl;
	
 	//he = gethostbyname(ip);
 	sa.sin_family = AF_INET;
 	 //*( (struct in_addr *) he->h_addr );
 	sa.sin_port = htons(port);
	
	
	
 	cout << "Socket opened" <<endl; 
	
	
	
	return 1;
	
 
}



SSocketMSG CPSocketCompileMSG( SGameMsg* msg )
{
	
	SSocketMSG Smsg;
	Smsg.type = msg->type;
	Smsg.gmsgT = msg->TimeStemp;
	Smsg.sendersIP = myIpAddr();
	Smsg.size = msg->size;
	Smsg.target = msg->target;
	Smsg.targetsIP = 0;
	for (int i=0; i< CID.size(); i++)
	{
		if ( CID[i].iGameObjectID == msg->target )
		{
		Smsg.target = i;
		Smsg.targetsIP = CID[i].ip;
		}
			
	}

	/*if (msg->type == GMSG_FRAG)
		cout << "Smsg.target= "<<Smsg.target<<endl;
*/
	//to do: dodaj konverziju iz SGameMsg::float u one staticne stvari
	
	if (msg->size > 0)
		Smsg.f0 = msg->data[0];
	if (msg->size > 1)
		Smsg.f1 = msg->data[1];
	if (msg->size > 2)
		Smsg.f2 = msg->data[2];
	if (msg->size > 3)
		Smsg.f3 = msg->data[3];
	if (msg->size > 4)
		Smsg.f4 = msg->data[4];
	if (msg->size > 5)
		Smsg.f5 = msg->data[5];
	if (msg->size > 6)
		Smsg.f6 = msg->data[6];
	
	
	return Smsg;
}



int CPSocketSend(SSocketMSG* Smsg)
{

   //ip = GetIP();
   sa.sin_addr.s_addr = Smsg->recepiant;//inet_addr("127.0.0.1");//INADDR_ANY;
	
	
   msghdr Msghdr;
   memset (&Msghdr,0,sizeof(msghdr));
   iovec iov;
   iov.iov_base = (caddr_t)(Smsg);
   iov.iov_len = sizeof(SSocketMSG);
	
    Msghdr.msg_name = (caddr_t) &sa;
	Msghdr.msg_namelen = sizeof (sa);
	Msghdr.msg_iov = &iov;
	Msghdr.msg_iovlen = 1;
 
	Smsg->time = game->GetTime();
	
   sendmsg( sock, &Msghdr, 0 );
	
/*	sendto( sock, Smsg, sizeof(SSocketMSG), 
      0, (const sockaddr *)&sa, sizeof(struct sockaddr_in) );*/
	 
  return 1;
}

int CPSocketSend(SGameMsg* msg)
{
	SSocketMSG Smsg = CPSocketCompileMSG( msg );
	
	for (int i =0;i<CID.size();i++)
	{
		Smsg.recepiant = CID[i].ip;
		CPSocketSend( &Smsg );
	}
	return 1;
}

int CPSocketClose()
{
	close(sock);
 	return 0;
}

vector<char*> CPSocketConnect(unsigned long IP)
{
	
	
 cout << " Attempting to connect "<< endl;
	vector<char*> v;
	
    SSocketMSG Smsg;
	
	Smsg.type = SMSG_CONNECT;
	if (IP!=0 ) Smsg.type = SMSG_CONNECT_BACK;
		
	Smsg.sendersIP = myIpAddr();
	if (IP == 0)
	  Smsg.recepiant = inet_addr("255.255.255.255");//myIpAddr();
	else Smsg.recepiant = IP;
		
	Smsg.data[0] = game->GetGameObjects()[1]->type;
	Smsg.data[1] = game->GetGameObjects()[1]->iGraphicObjectId;
	Smsg.data[2] = game->GetGameObjects()[1]->iTexture1Id;
	Smsg.data[3] = game->GetGameObjects()[1]->iTexture2Id;
	Smsg.data[4] = game->GetGameObjects()[1]->color[0];
	Smsg.data[5] = game->GetGameObjects()[1]->color[1];
	Smsg.data[6] = game->GetGameObjects()[1]->color[2];
	Smsg.data[7] = game->GetGameObjects()[1]->color[3];
	Smsg.data[8] = game->GetGameObjects()[1]->data[0];
	Smsg.data[9] = game->GetGameObjects()[1]->data[1];
	Smsg.data[10] = game->GetGameObjects()[1]->iActive;

	Smsg.f0 = game->GetGameObjects()[1]->pos.x;
        Smsg.f1 = game->GetGameObjects()[1]->pos.y;
        Smsg.f2 = game->GetGameObjects()[1]->pos.z;
        Smsg.f3 = game->GetGameObjects()[1]->rot.x;
	Smsg.f4 = game->GetGameObjects()[1]->rot.y;
	Smsg.f5 = game->GetGameObjects()[1]->rot.z;
	
   CPSocketSend(&Smsg);
//	cout<<"bla"<<endl;
	
	//if (CID.size() > 1)

	/*{
		SSocketMSG SmsgSync;
	
		SmsgSync.type = SMSG_SYNC_TIME;
		SmsgSync.sendersIP = myIpAddr();
		timeoffset = SmsgSync.time = game->GetTime();
	
		if ( CID[0].ip != myIpAddr() )
			SmsgSync.recepiant = CID[0].ip;
		else
			SmsgSync.recepiant = CID[1].ip;
	//	SmsgSync.recepiant = inet_addr("255.255.255.255");
		CPSocketSend(&SmsgSync);
	}*/
	return v;
	
}


// REMOVE 

void setip(unsigned long i)
{

//	pthread_mutex_init (&m, NULL);
	ip = i;
}

unsigned long getip()
{
	return ip;
}
