#ifndef CP_Kazuky
#define CP_Kazuky

#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>
#include <vector>
#include <iostream>
#include <pthread.h>

using namespace std;

#define MAX_MUTEX  100
#define MAX_THREADS  100

class CCpSDLTreader
{
	protected:
	
		pthread_mutex_t MutexArray[MAX_MUTEX];
		SDL_Thread* ThreadArray[MAX_THREADS];
		int mcount;
		int tcount; 
	
	public:
		CCpSDLTreader()
		{
			mcount = 0;
			tcount = 0;
			cout << "Init: CpSDLTreader"<<endl;
		}
		
		virtual int InitializeMutex( )
		{
			if (mcount == MAX_MUTEX ) return -1;
				
			pthread_mutex_init (&MutexArray[mcount], NULL);

			mcount++;
			return mcount - 1;
		}
		
		virtual void LockMutex(int i)
		{
	
			pthread_mutex_lock(&MutexArray[i]);
		}
		
		virtual void UnlockMutex(int i)
		{
			pthread_mutex_unlock(&MutexArray[i]);
		}
		
		virtual int CreateThread ( int (*fn)(void *), void *data )
		{		
			pthread_t thread;	
			
			cout<<SDL_CreateThread( fn, data)<<endl;
			//pthread_create (&thread, NULL, fn, data) ;
			return tcount - 1;
			
		}
		
		virtual void Close()
		{
			for (int i = 0; i< tcount; i++)
			{
				SDL_KillThread(ThreadArray[tcount]);
			}
		}
};

#endif
