#include <Interfaces.h>
#include <iostream>

struct SGameObject;

char* getMsgString(int type)
{
  switch ( type ) {

  case 200 : 
    return "GMSG_MOVE_TO_LOC";
    break;
  
  case 201 : 
    return "GMSG_CHANGE_ANGLES";
    break;

case 202 : 
    return "GMSG_SHOOT";
    break;

case 203 : 
    return "GMSG_DEATH";
    break;

case 204 : 
    return "GMSG_ACCELERATE";
    break;

case 205 : 
    return "GMSG_DAMAGE";
    break;

case 206 : 
    return "GMSG_FRAG";
    break;

case 302 : 
    return "GMSG_POWERUP_APPEAR";
    break;

  default : 
    return "Unknown";

  }
}

bool Less(Line2vf p, Line2vf l)
	{
		if ( p.v1.x != l.v1.x ) 
			return ( p.v1.x < l.v1.x );
		else
		if ( p.v1.y != l.v1.y ) 
			return ( p.v1.y < l.v1.y );
		else
		if ( p.v1.z != l.v1.z ) 
			return ( p.v1.z < l.v1.z );

		else
		if ( p.v2.x != l.v2.x ) 
			return ( p.v2.x < l.v2.x );
		else
		if ( p.v2.y != l.v2.y ) 
			return ( p.v2.y < l.v2.y );
		else
		if ( p.v2.z != l.v2.z ) 
			return ( p.v2.z < l.v2.z );
	}

bool LessInv(Line2vf p, Line2vf l)
	{
		if ( p.v2.x != l.v2.x ) 
			return ( p.v2.x < l.v2.x );
		else
		if ( p.v2.y != l.v2.y ) 
			return ( p.v2.y < l.v2.y );
		else
		if ( p.v2.z != l.v2.z ) 
			return ( p.v2.z < l.v2.z );
	
		else
		if ( p.v1.x != l.v1.x ) 
			return ( p.v1.x < l.v1.x );
		else
		if ( p.v1.y != l.v1.y ) 
			return ( p.v1.y < l.v1.y );
		else
		if ( p.v1.z != l.v1.z ) 
			return ( p.v1.z < l.v1.z );
	}
bool LessCross(Line2vf p, Line2vf l)
	{
		if ( p.v1.x != l.v2.x ) 
			return ( p.v1.x < l.v2.x );
		else
		if ( p.v1.y != l.v2.y ) 
			return ( p.v1.y < l.v2.y );
		else
		if ( p.v1.z != l.v2.z ) 
			return ( p.v1.z < l.v2.z );

		else
		if ( p.v2.x != l.v1.x ) 
			return ( p.v2.x < l.v1.x );
		else
		if ( p.v2.y != l.v1.y ) 
			return ( p.v2.y < l.v1.y );
		else
		if ( p.v2.z != l.v1.z ) 
			return ( p.v2.z < l.v1.z );
	}

Vector3f Vector3f::CrossProduct(Vector3f v)
{
	return Vector3f( y*v.z - z*v.y,  z*v.x - x*v.z,  x*v.y - y*v.x );
}

Vector3f Vector3f::Rescale(float f)
{
	float l = x*x+y*y+z*z;
	if (l==0)
	{
		//cout<< "Error: div 0 in Vector3d::Rescale()\n";
		return *this;
	}
	float a = f/l;
	a=sqrt(a);
	x*=a;
	y*=a;
	z*=a;
	return *this;
}

SGameMsg* STankPrototype::Action(unsigned long t, int i)
{

	if (this->data[10]>0.0)
	{
		this->data[10]-=t;
	}

	if (this->data[10]<=0)
	{	
		this->data[9]=0;
		this->color[0]=this->color[1]=this->color[2]=0;
		
		
	}
	
	if (this->data[2]==0.0) return NULL;
	Vector3f npos = pos;
				Vector3f dir(-sinf(rot.y/180.0f*3.14f)*cosf(rot.x/180.0f*3.14f),
				   sinf(rot.x/180.0f*3.14f),
				   -cosf(rot.y/180.0f*3.14f)*cosf(rot.x/180.0f*3.14f));
				  
				float s =  this->data[0];
				float inert =  this->data[2];
				npos = npos + dir*s*t*inert*(data[PBTPD_ENGINE]+0.25);
				  
				SGameMsg* msg = new SGameMsg[2];
				msg[0].type = GMSG_MOVE_TO_LOC;
				msg[0].target = i;
				msg[0].size = 3;
				msg[0].data = new float[3];
				msg[0].data[0] = npos.x;
				msg[0].data[1] = npos.y;
				msg[0].data[2] = npos.z;


				msg[1].type = GMSG_ACCELERATE;
				msg[1].target = i;
				msg[1].size = 1;
				msg[1].data = new float[1];
				
				if ( this->data[2] < 0.0 ) 
				  {
					msg[1].data[0] = 0.003*t;

				  }

				if ( this->data[2] > 0.0 ) 
				  {
					msg[1].data[0] = -0.003*t;
				  }


				return msg;	
}

