
#ifndef _Panzer_Battalion
#define _Panzer_Battalion


const int PBOT_NORMAL 		= 0;
const int PBOT_TANK_PROTOTYPE   = 1;
const int PBOT_MAP              = 2;
const int PBOT_SHOT             = 3;
const int PBOT_POWERUP   	=-1;

#include <Interfaces.h>
#include <CpSDL.h>
#include <vector>
#include <CpThreadMaster.h>
#include <CpSockets.h>
#include <CpSound.h>
#include <GameMenu.h>

struct SSavedStates
{
	vector<SGameObject*> SavedStates[10];
	Uint32 TimeOfSave[10];
	Uint32 time;
	int last;
	SSavedStates()
	{
	  last=0;
	}

	void SaveState(vector<SGameObject*> State, Uint32 t)
	{

		if ( t-time < 1000 ) return;
		
		last++;
		if (last > 9) last = 0;

//-------------------------------------------------------------------------NEEDS WORK-------------------------
//		SavedStates[last] = State;

		for (int i = 0; i < SavedStates[last].size(); i++ )
			{
			  delete SavedStates[last][i]->data;
			  delete SavedStates[last][i];
			}
		SavedStates[last].clear();

		for (int i = 0; i < State.size(); i++)
			{
				SGameObject* o;
			
				if (State[i]->type == PBOT_TANK_PROTOTYPE )
					{
					   o = new STankPrototype;
					}else o = new SGameObject;

				(*o) = (*State[i]);
				o->data = new float[ o->size ];
				for ( int j = 0; j < o->size; j++ )
					o->data[j] = State[i]->data[j];

					SavedStates[last].push_back(o);	
			}
		TimeOfSave[last] = t; 	
		
		time = t;
		
	}

	void GetState(vector<SGameObject*> &s, int tw)
	{
 
               // printf("0\n");

                int state = last - tw;

		if ( state <0 ) state += 10;

		for ( int i = 0; i < s.size(); i++ )
			{
				//delete s[i]->data;
				//s[i]->data=NULL;
			}

               // printf("1\n");
               //  printf("1\n");

		s.clear();	

              //  printf("2\n");

		for (int i = 0; i < SavedStates[state].size(); i++)
			{
				SGameObject* o;
			
				if (SavedStates[state][i]->type == PBOT_TANK_PROTOTYPE )
					{
					   o = new STankPrototype;
					}else o = new SGameObject;

                            //   printf("3\n");

				(*o) = (*SavedStates[state][i]);
				o->data = new float[ o->size ];
				for ( int j = 0; j < o->size; j++ )
					o->data[j] = SavedStates[state][i]->data[j];


                           //    printf("4\n");

					s.push_back(o);	
			}

               //  printf("5\n");
		//s = SavedStates[state];*/
	  
	}
	
	Uint32 GetTime(int i)
	{
	  
	  int state = last - i;

   	  if ( state <0 ) state += 10;

	  return TimeOfSave[state];
	}
};

class CPanzer_Battalion : IGameInterface
{
	protected:
	vector<SGameObject*> pGameObjectArray;
	vector<int> GameEffectObjectArray;
	SSavedStates SavedStates;

	int iGameObjectCount;
	
	CCpSDL* pWindowUnit;
	CCpGl* pGraphicUnit;
	CCpSDLTreader* pThreadUnit;
	CCpSound* pSoundUnit;
	int iMSGMutex;
	
	GLboolean bRunning;
	
	virtual void ActOnMessages();
	virtual void ActOnMessage(SGameMsg msg);
	virtual void CalculateBB(SGameObject &o);
	
	virtual Vector3f RCollision(Vector3f v, int oId);
	virtual Vector3f MCollision(Vector3f v, int oId);
	virtual Vector3f ACollision(Vector3f v, int oId);
	
	public:	
	CPanzer_Battalion(char* ip, char* outputstr);
	virtual void Run();
	virtual void ShutDown(){ bRunning=false; };
	virtual int LoadObjects(char* s);
	virtual int LoadTextures(char* s);
	virtual int LoadShaders(char* s);
	virtual int LoadModels(char* s);
	virtual int LoadSounds(char* s);
	virtual vector<SGameObject*> GetGameObjects () {return pGameObjectArray;}
	virtual vector<int> GetGameEffectObjects () {return GameEffectObjectArray;}
	virtual int AddGameObject( SGameObject* obj );
	virtual void AddMsg (SGameMsg msg) { AddMsg(msg,true); }
	virtual void AddMsg (SGameMsg msg, bool Lock);
	virtual void Close()
	{
		pThreadUnit->Close();
		CPSocketClose();
	}
	virtual unsigned long GetTime()
	{
		return pWindowUnit->GetTime();
	}
	virtual void SetTimeOffset(unsigned long o)
	{
		pWindowUnit->SetTimeOffset(o);
	}
};


#endif
