
#include <Panzer_Battalion.h>
#include <stdio.h>
#include <iostream>
#include <cstdlib> 

using namespace std;
const Uint32 PB_MSG_LIFE = 1000000;


CPanzer_Battalion :: CPanzer_Battalion(char* ip)
{

 pWindowUnit = new CCpSDL("Panzer Battalion","");
 pWindowUnit->SetGameInterface(this);
 pGraphicUnit = new CCpGl();
 pWindowUnit->SetGraficInterface( (IGraphicInterface*)pGraphicUnit);
 pGraphicUnit->SetGameInterface( this );
 pThreadUnit = new CCpSDLTreader();
 iMSGMutex = pThreadUnit->InitializeMutex();
	
 bRunning = true;
	
 CPSocketOpen();
 
 pThreadUnit->CreateThread( CPSocketListen, (void*) this );
 pThreadUnit->CreateThread( CPSocketListen, (void*) this );
 pThreadUnit->CreateThread( Lag, (void*) this );

	 
};

void CPanzer_Battalion :: Run()
{
 
cout << "RUN" << endl;
	
//if (getip()!=0)
 CPSocketConnect(0);	
 SavedStates.time = pWindowUnit->GetTime();
 unsigned long time = pWindowUnit->GetTime();


 while( bRunning )
    {
	
     pWindowUnit->CheckInput();

     unsigned long t = pWindowUnit->GetTime() - time;
	
     for (int i = 0; i<pGameObjectArray.size(); i++)
	{
		if (pGameObjectArray[i]->type == 1) 
		{

		SGameMsg* msg = pGameObjectArray[i]->Action(t);
		if (msg != NULL)
			{
			  msg->TimeStemp = GetTime();
			  CPSocketSend(msg);
		          this->AddMsg(*msg);
			}
		}
	}

     time = pWindowUnit->GetTime();



     this->ActOnMessages();
     if (pGameObjectArray[1]->iActive!=0) 
	 {
	   Vector3f sdir(-sinf(pGameObjectArray[1]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[1]->rot.x/180.0f*3.14f),
       sinf(pGameObjectArray[1]->rot.x/180.0f*3.14f),
       -cosf(pGameObjectArray[1]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[1]->rot.x/180.0f*3.14f));

	    pGraphicUnit->SetAngles(pGameObjectArray[1]->rot.x/180.0f*3.14f,pGameObjectArray[1]->rot.y/180.0f*3.14f + 3.14f);
	    pGraphicUnit->SetPos(pGameObjectArray[1]->pos + Vector3f(0,40,0) - sdir*20 );
	 }
		
     pGraphicUnit->Draw();
     pWindowUnit->EndCyrcle();
     
    }
 

};

Vector3f CPanzer_Battalion :: MCollision(Vector3f v, int oId)
{
 
 Vector3f sdir(-sinf(pGameObjectArray[oId]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[oId]->rot.x/180.0f*3.14f),
       sinf(pGameObjectArray[oId]->rot.x/180.0f*3.14f),
       -cosf(pGameObjectArray[oId]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[oId]->rot.x/180.0f*3.14f));
 
 Vector3f s_back_right = v - ( sdir * pGameObjectArray[oId]->back ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->right,0) );
 Vector3f s_back_left = v - ( sdir * pGameObjectArray[oId]->back ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->left,0) );
 Vector3f s_front_right = v - ( sdir * pGameObjectArray[oId]->front ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->right,0) );
 Vector3f s_front_left = v - ( sdir * pGameObjectArray[oId]->front ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->left,0) );
 
   
 for (int i = 1; i<pGameObjectArray.size(); i++)
 if (i!=oId)
 if (pGameObjectArray[i]->iActive)
 {
  Vector3f dir(-sinf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
       sinf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
       -cosf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f));
  
  Vector3f back_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
  Vector3f back_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
  Vector3f front_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
  Vector3f front_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
  
  Vector3f tmp;
 
  tmp = s_back_right;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;

  tmp = s_back_left;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;  
  
  tmp = s_front_right;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
  
  tmp = s_front_left;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
  
  
  tmp = back_right;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
  
  tmp = back_left;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
		
  tmp = front_right;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
		
  tmp = front_left;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
  
 }
 
 return v;
}

Vector3f CPanzer_Battalion :: RCollision(Vector3f v, int oId)
{
 Vector3f sdir(-sinf(v.y/180.0f*3.14f)*cosf(v.x/180.0f*3.14f),
       sinf(v.x/180.0f*3.14f),
       -cosf(v.y/180.0f*3.14f)*cosf(v.x/180.0f*3.14f));
 
 Vector3f s_back_right = pGameObjectArray[oId]->pos - ( sdir * pGameObjectArray[oId]->back ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->right,0) );
 Vector3f s_back_left = pGameObjectArray[oId]->pos - ( sdir * pGameObjectArray[oId]->back ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->left,0) );
 Vector3f s_front_right = pGameObjectArray[oId]->pos - ( sdir * pGameObjectArray[oId]->front ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->right,0) );
 Vector3f s_front_left = pGameObjectArray[oId]->pos - ( sdir * pGameObjectArray[oId]->front ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->left,0) );
 
   
 for (int i = 1; i<pGameObjectArray.size(); i++)
 if (i!=oId)
 if (pGameObjectArray[i]->iActive)
 {
  Vector3f dir(-sinf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
       sinf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
       -cosf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f));
  
  Vector3f back_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
  Vector3f back_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
  Vector3f front_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
  Vector3f front_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
  
  Vector3f tmp;
 
  tmp = s_back_right;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;

  tmp = s_back_left;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;  
  
  tmp = s_front_right;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
  
  tmp = s_front_left;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
  
  
  tmp = back_right;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
  
  tmp = back_left;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
  
  tmp = front_right;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
		
  tmp = front_left;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
		
	}
	
	return v;
}

void CPanzer_Battalion :: ActOnMessage(SGameMsg msg)
{
	if ( msg.type == GMSG_START_MOVE_FORWARD )
	{
		Vector3f v(-sinf(pGameObjectArray[msg.target]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[msg.target]->rot.x/180.0f*3.14f),
				   sinf(pGameObjectArray[msg.target]->rot.x/180.0f*3.14f),
				   -cosf(pGameObjectArray[msg.target]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[msg.target]->rot.x/180.0f*3.14f));
		
		pGameObjectArray[msg.target]->pos= pGameObjectArray[msg.target]->pos + ( v*
           ( (pWindowUnit->GetTime() - msg.TimeStemp )/25.0 ) );
  return;
	}
	
	if ( msg.type == 216 )
	{
		cout << msg.TimeStemp <<" "<< pWindowUnit -> GetTime()<<endl;
		return;
	}

    if ( msg.type == GMSG_DAMAGE )
	{
		pGameObjectArray[msg.target]->data[PBTPD_ENGINE] -= msg.data[0];
		if (pGameObjectArray[msg.target]->data[PBTPD_ENGINE]<0) pGameObjectArray[msg.target]->data[PBTPD_ENGINE]=0;
     		pGameObjectArray[msg.target]->data[PBTPD_ARMOR] -= msg.data[1];
		if (pGameObjectArray[msg.target]->data[PBTPD_ARMOR]<0) pGameObjectArray[msg.target]->data[PBTPD_ARMOR]=0;
     		pGameObjectArray[msg.target]->data[PBTPD_GUN] -= msg.data[2];
		if (pGameObjectArray[msg.target]->data[PBTPD_GUN]<0) pGameObjectArray[msg.target]->data[PBTPD_GUN]=0;

	
	}    

    if ( msg.type == GMSG_DEATH )
	{
		pGameObjectArray[msg.target]->iActive = 0;
 	        pGameObjectArray[msg.target]->iTimer = msg.TimeStemp;
		return;
	}

     if ( msg.type == GMSG_FRAG )
	{

		if (msg.target ==1)
		cout <<"Frag!!!"<<endl; else cout << msg.target<<endl;
		pGameObjectArray[msg.target]->data[5] = 1.5;
		return;
	}

    if ( msg.type == GMSG_ACCELERATE )
	{
		pGameObjectArray[msg.target]->data[2] += msg.data[0]*(pGameObjectArray[msg.target]->data[PBTPD_ENGINE]/5.0f +0.8f);

		if (pGameObjectArray[msg.target]->data[2]>1.0) pGameObjectArray[msg.target]->data[2] = 1.0;
		if (pGameObjectArray[msg.target]->data[2]<-1.0) pGameObjectArray[msg.target]->data[2] = -1.0;	
		
		return;
	}
	
	if ( msg.type == GMSG_MOVE_TO_LOC )
	{
		
		Vector3f v(msg.data[0],msg.data[1],msg.data[2]);
		
		v = MCollision(v,msg.target);
		
		pGameObjectArray[msg.target]->pos=v;
		return;
	}
	
	if ( msg.type == GMSG_CHANGE_ANGLES )
	{
		Vector3f v(msg.data[0],msg.data[1],0);
		pGameObjectArray[msg.target]->rot = RCollision(v,msg.target);
		return;
	}
	
	if ( msg.type == GMSG_SHOOT )
	{
		
		int index = -1;
		float distance = 100000.0;
		
		if (msg.TimeStemp - pGameObjectArray[msg.target]->iTimer > 1000 + 2000*(1 - pGameObjectArray[msg.target]->data[PBTPD_GUN]))
		{
		
			if (pGameObjectArray[msg.target]->iActive == true)
			{
				pGameObjectArray[msg.target]->iTimer = msg.TimeStemp;
   
    //for (int i = 1; i< pGameObjectArray.size(); i++)
//---------------------------------------move a bit to the back-----------------------------------------
if (msg.target==1)
		{
			Vector3f dir(-sinf(pGameObjectArray[1]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[1]->rot.x/180.0f*3.14f),
				   sinf(pGameObjectArray[1]->rot.x/180.0f*3.14f),
				   -cosf(pGameObjectArray[1]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[1]->rot.x/180.0f*3.14f));

			
		  		Vector3f pos = pGameObjectArray[1]->pos - dir;
				SGameMsg msg;
				msg.type = GMSG_MOVE_TO_LOC;
				msg.target = 1;
				msg.size = 3;
				msg.data = new float[3];
				msg.data[0] = pos.x;
				msg.data[1] = pos.y;
				msg.data[2] = pos.z;
				msg.TimeStemp = GetTime();
				CPSocketSend(&msg);
				MsgArray.push_back(msg);
				
		}
//-------------------------------------move a bit to the back(done)-------------------------------------
	int i = 1;
	if ( i != msg.target )
    {


		int s = msg.target;
		
     Vector3f sdir(-sinf(pGameObjectArray[s]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[s]->rot.x/180.0f*3.14f),
        sinf(pGameObjectArray[s]->rot.x/180.0f*3.14f),
         -cosf(pGameObjectArray[s]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[s]->rot.x/180.0f*3.14f));
 
 
     Vector3f dir(-sinf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
        sinf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
        -cosf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f));
  
     Vector3f back_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
     Vector3f back_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
     Vector3f front_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
     Vector3f front_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
    
     if ( ( ((back_right - pGameObjectArray[s]->pos ).CrossProduct(sdir)).y * ((back_left - pGameObjectArray[s]->pos ).CrossProduct(sdir)).y <= 0 )  ||
      ( ((back_right - pGameObjectArray[s]->pos ).CrossProduct(sdir)).y * ((front_right - pGameObjectArray[s]->pos ).CrossProduct(sdir)).y <= 0 ) )
     {
      if ( ( ((back_right - pGameObjectArray[s]->pos ).CrossProduct(back_right - back_left)).y * ( (back_right - (pGameObjectArray[1]->pos + (sdir*10000) ) ).CrossProduct(back_right - back_left)).y < 0 ) ||
       ( ((back_right - pGameObjectArray[s]->pos ).CrossProduct(back_right - front_right)).y * ( (back_right - (pGameObjectArray[1]->pos + (sdir*10000) ) ).CrossProduct(back_right - front_right)).y < 0 ) )
          if  ( ( ( pGameObjectArray[s]->pos - pGameObjectArray[i]->pos ).Rescale(1)).DotProduct(sdir) < 0.0 )
								{
									Vector3f a ,b;
									
         if ( (back_right - back_left).CrossProduct(back_right - pGameObjectArray[s]->pos).y < 0 )
         {
          a = pGameObjectArray[s]->pos - back_right;
          b = pGameObjectArray[s]->pos - back_left;
          float dist = (a.CrossProduct(b).Length())/( a.CrossProduct(sdir).Length() + b.CrossProduct(sdir).Length() );
										
										if ( dist < distance) 
										{
											distance = dist;
											index = i;
										}
									}
									
         if ( (front_right - front_left).CrossProduct(front_right - pGameObjectArray[s]->pos).y > 0 )
         {
          a = pGameObjectArray[s]->pos - front_right;
          b = pGameObjectArray[s]->pos - front_left;
          
          float dist = (a.CrossProduct(b).Length())/( a.CrossProduct(sdir).Length() + b.CrossProduct(sdir).Length() );
          
          if ( dist < distance) 
          {
           distance = dist;
           index = i;
          }
         }
         
         if ( (front_right - back_right).CrossProduct(front_right - pGameObjectArray[s]->pos).y > 0 )
         {
          a = pGameObjectArray[s]->pos - front_right;
          b = pGameObjectArray[s]->pos - back_right;
          
          float dist = (a.CrossProduct(b).Length())/( a.CrossProduct(sdir).Length() + b.CrossProduct(sdir).Length() );
          
          if ( dist < distance) 
          {
           distance = dist;
           index = i;
          }
         
         }
         
         if ( (front_left - back_left).CrossProduct(front_left - pGameObjectArray[s]->pos).y < 0 )
         {
          a = pGameObjectArray[s]->pos - front_left;
          b = pGameObjectArray[s]->pos - back_left;
          
          float dist = (a.CrossProduct(b).Length())/( a.CrossProduct(sdir).Length() + b.CrossProduct(sdir).Length() );
          
          if ( dist < distance) 
          {
           distance = dist;
           index = i;
          }
         // cout << i << " left " << dist << endl;
         }     
         
        }
     }
   
  //  } 
    cout << "Result: " << index << endl;
    if (index!=-1)
	{

	const float dmg = 0.8f;

      float edmg,admg,gdmg;
      float tmp1, tmp2, tmp3, sum;
      tmp1 = (rand()%100)/100.0f; tmp2 = (rand()%100)/100.0f; tmp3 = (rand()%100)/100.0f;
      sum = tmp1+tmp2+tmp3;
      sum *= (pGameObjectArray[index]->data[PBTPD_ARMOR]/2.0f) + 0.5f;

      edmg = dmg * tmp1 / sum;
      admg = dmg * tmp2 / sum;
      gdmg = dmg * tmp3 / sum;


      SGameMsg sNewMsg;
		
      sNewMsg.type = GMSG_DAMAGE;
      sNewMsg.target = 1;
      sNewMsg.size = 3;
      sNewMsg.data = new float[sNewMsg.size];
      sNewMsg.data[0] = edmg;
      sNewMsg.data[1] = admg;
      sNewMsg.data[2] = gdmg;
      sNewMsg.TimeStemp = pWindowUnit->GetTime();
		
      this->ActOnMessage(sNewMsg);
      CPSocketSend(&sNewMsg);

      if ( ( (pGameObjectArray[index]->data[PBTPD_ENGINE]==0) && (pGameObjectArray[index]->data[PBTPD_ARMOR]==0) )||
         ((pGameObjectArray[index]->data[PBTPD_GUN]==0) && (pGameObjectArray[index]->data[PBTPD_ARMOR]==0))||
	 ((pGameObjectArray[index]->data[PBTPD_ENGINE]==0) && (pGameObjectArray[index]->data[PBTPD_GUN]==0)) )
	      {
		SGameMsg sNewMsg;
		
		sNewMsg.type = GMSG_DEATH;
		sNewMsg.target = 1;
		sNewMsg.size = 0;
		sNewMsg.TimeStemp = pWindowUnit->GetTime();
		
		this->ActOnMessage(sNewMsg);
		CPSocketSend(&sNewMsg);

		{
		SGameMsg sNewMsg;
		sNewMsg.type = GMSG_FRAG;
		sNewMsg.target = msg.target;
		sNewMsg.size = 0;
		sNewMsg.TimeStemp = pWindowUnit->GetTime();
		
		this->ActOnMessage(sNewMsg);
		CPSocketSend(&sNewMsg);
		}
	   
		   /*if (pGameObjectArray[index]->type == 1) 
		     {
      
		      	pGameObjectArray[index]->iActive = 0;
		     	pGameObjectArray[index]->iTimer = pWindowUnit->GetTime();
      
    		     }*/
     	     }
      
    }
    } 

   }else
   {
    pGameObjectArray[msg.target]->iActive = 1;
    pGameObjectArray[msg.target]->iTimer = pWindowUnit->GetTime()-500;
    pGameObjectArray[msg.target]->data[PBTPD_ENGINE] = 1;
    pGameObjectArray[msg.target]->data[PBTPD_ARMOR] = 1;
    pGameObjectArray[msg.target]->data[PBTPD_GUN] = 1;
    bool b =true;
    while (b)
    {
     Vector3f v;
     int w = pGameObjectArray[0]->data[0];
     int h = pGameObjectArray[0]->data[1];
	 //cout << "1"<< endl;
     v.x = random() % 1000;//w;
     v.y = 0;
     v.z = random() % 1000;//h;
   //  cout << "2"<< endl;
     if (MCollision(v, msg.target) == v)
     {      
      pGameObjectArray[msg.target]->pos = v;
      b = false;
     }
	 //cout << "3"<< endl;
    }
    
   }    
   
   
  }

 }
}

void CPanzer_Battalion :: ActOnMessages()
{
	
 pThreadUnit->LockMutex(iMSGMutex);	
	
 if (MsgArray.empty()) 
 {
	 pThreadUnit->UnlockMutex( iMSGMutex );
	 return;
 }
 
  int execution_started = 0;

 for (int i = 0; i < MsgArray.size(); i++)
  {


	if ( ( MsgArray[i].executed == false ) || ( execution_started == 1 ) )
	{

  		Uint32 t = pWindowUnit->GetTime() - MsgArray[i].TimeStemp;

		if ( (execution_started == 0) && ( MsgArray[i].late == true) )
		{
			//cout << "Warping "<<  t / 1000 + 1 << " seconds"<<endl;
			SavedStates.GetState(pGameObjectArray,  t / 1000 + 1 );

			while ( MsgArray[i].TimeStemp > SavedStates.GetTime(t / 1000 + 1) )
				i--;			
		}

		MsgArray[i].executed = true;
		execution_started = 1;
		this->ActOnMessage(MsgArray[i]);

	}
   	

  }

	/*int k = 0;
  for ( int i = 0; i < MsgArray.size(); i++ )
	{

		if ( pWindowUnit->GetTime() - MsgArray[i].TimeStemp < PB_MSG_LIFE )
       		    {
			k=i;
			break;
		    }
	}

  for ( int i = 0; i < k;i++)
	{
		MsgArray.erase( MsgArray.begin() );
	}*/
 
  SavedStates.SaveState(pGameObjectArray, pWindowUnit->GetTime());

 pThreadUnit->UnlockMutex( iMSGMutex );
 
}

int CPanzer_Battalion :: LoadModels(char* c)
{
 cout << "loading models\n";

 pGraphicUnit->LoadObjects(c);
 
 
 return 1;
};

int CPanzer_Battalion :: LoadTextures(char* c)
{
 cout << "loading textures\n";
 
 pGraphicUnit->LoadTextures(c);
 
 
 return 1;
};

void CPanzer_Battalion :: CalculateBB(SGameObject &o)
{
 SGraphicObject* g;
 
 g = pGraphicUnit->GetObject(o.iGraphicObjectId); 
 Vector3f* v = pGraphicUnit->GetVertices();
 
 o.back = o.front = v[g->pIndexArray[0]].z;
 o.right = o.left = v[g->pIndexArray[0]].x;
 
 for (int i =1; i < g->iIndexCount;i++ )
 {
  
  if ( o.back < v[g->pIndexArray[i]].z ) o.back = v[g->pIndexArray[i]].z;
  if ( o.front > v[g->pIndexArray[i]].z ) o.front = v[g->pIndexArray[i]].z;
  if ( o.right > v[g->pIndexArray[i]].x ) o.right = v[g->pIndexArray[i]].x;
  if ( o.left < v[g->pIndexArray[i]].x ) o.left = v[g->pIndexArray[i]].x;
   
 }
 
 
 
}

int CPanzer_Battalion :: AddGameObject( SGameObject* obj )
{
	this->CalculateBB(*obj);
	pGameObjectArray.push_back(obj);
	iGameObjectCount++;
	return pGameObjectArray.size() - 1;
}
int CPanzer_Battalion :: LoadObjects(char* c)
{
 cout << "loading objects\n";
 
 FILE* f = fopen(c,"r");
 
 fscanf( f, "%d", &iGameObjectCount);
 SGameObject* tmpObject;
 
 for ( int i = 0; i < iGameObjectCount; i++ )
 {
 	tmpObject = new SGameObject;

  fscanf(f,"%d",&(tmpObject->type));
  fscanf(f,"%d",&(tmpObject->iGraphicObjectId));
  fscanf(f,"%f",&(tmpObject->pos.x));
  fscanf(f,"%f",&(tmpObject->pos.y));
  fscanf(f,"%f",&(tmpObject->pos.z));
  fscanf(f,"%f",&(tmpObject->rot.x));
  fscanf(f,"%f",&(tmpObject->rot.y));
  fscanf(f,"%f",&(tmpObject->rot.z));
  fscanf(f,"%d",&(tmpObject->iTexture1Id));
  fscanf(f,"%d",&(tmpObject->iTexture2Id));
  fscanf(f,"%f",&(tmpObject->color[0]));
  fscanf(f,"%f",&(tmpObject->color[1]));
  fscanf(f,"%f",&(tmpObject->color[2]));
  fscanf(f,"%f",&(tmpObject->color[3]));
  this->CalculateBB(*tmpObject); 
  tmpObject->iActive = 1;

  if (tmpObject->type == PBOT_NORMAL)
   pGameObjectArray.push_back(tmpObject);
  else
  if (tmpObject->type == PBOT_TANK_PROTOTYPE)
  {
   STankPrototype* tmpTankprototype = new STankPrototype(*tmpObject);
   fscanf(f,"%f",&(tmpTankprototype->data[0]));
   fscanf(f,"%f",&(tmpTankprototype->data[1]));
   tmpTankprototype->iTimer = pWindowUnit->GetTime();
   tmpTankprototype->iActive = 0;
   pGameObjectArray.push_back(tmpTankprototype);
  }
  if (tmpObject->type == PBOT_MAP)
  {
   tmpObject->size = 2;
   tmpObject->data = new float[tmpObject->size];
   tmpObject->data[0] = pGraphicUnit->pVertexArray[pGraphicUnit->pGraphicObjectArray[tmpObject->iGraphicObjectId].pIndexArray[0]].x;
   if (tmpObject->data[0]<0) tmpObject->data[0] = -tmpObject->data[0];

   tmpObject->data[1] = pGraphicUnit->pVertexArray[pGraphicUnit->pGraphicObjectArray[tmpObject->iGraphicObjectId].pIndexArray[0]].z;
   if (tmpObject->data[1] < 0) tmpObject->data[1] = -tmpObject->data[1];

   pGameObjectArray.push_back(tmpObject);
  }
   if (tmpObject->type == PBOT_SHOT)
   {
   GameEffectObjectArray.push_back(i);
   tmpObject->iActive = 0;
   pGameObjectArray.push_back(tmpObject);
   
   }
 }

 
 cout << "objects loaded" << endl;
 return 1;
};

void CPanzer_Battalion :: AddMsg(SGameMsg msg)
{
	pThreadUnit->LockMutex(iMSGMutex);


	//cout << pWindowUnit->GetTime() <<" "<<msg.TimeStemp<< endl;
	/*if (pWindowUnit->GetTime() - msg.TimeStemp > PB_MSG_LIFE ) 
	    {
		pThreadUnit->UnlockMutex(iMSGMutex);
		return;
	    }*/


 if (msg.type>0)
{
 
  vector<SGameMsg>::iterator it = MsgArray.begin();
int i;
  for (i = 0;i<MsgArray.size();i++)
  {
    if (MsgArray[i].TimeStemp > msg.TimeStemp)
	{
	  //cout << "time warp"<<endl;
	  msg.late = true;
	  MsgArray.insert(it,msg);
          break;
	}
     it++;
  }

   if (i==MsgArray.size()) MsgArray.push_back(msg);
}

 else
 {
  vector<SGameMsg>::iterator Iterator;
     Iterator = MsgArray.begin();
  for (uint i = 0; i < MsgArray.size(); i++, Iterator++)
  {
   if ( ( Iterator->type == - msg.type ) && ( Iterator->target == msg.target ) )
    MsgArray.erase(Iterator);
  }
 }
 
 pThreadUnit->UnlockMutex(iMSGMutex);
}

int CPanzer_Battalion :: LoadShaders(char* c)
{
 cout << "loading shaders\n";
 
 pGraphicUnit->LoadShaders(c);
 
 return 1;
};
